ctools - Support #3476

[Plot spectrum for different version of CTools]
12/04/2020 11:47 AM - Diaz-Bahamondes Christian

Status: Closed Start date: 12/04/2020
Priority: Normal Due date:

Assigned To: Tibaldo Luigi % Done: 100%
Category: Estimated time: 0.00 hour
Target version:

Description

Hi, | am Christian Diaz and | have a problem with the last update of CTools, this is: when | use the console to plot the spectrums by
different simulations (with a different version of ctools), doesn't work and show me this bug:

"(chirri) Christians-MacBook-Pro:Graphs chirri$ python show_spectrum.py SpecedispWoALPs1 fits

Traceback (most recent call last):

File "show_spectrum.py", line 296, in &lt;module&gt;

show_spectrum()

File "show_spectrum.py”, line 284, in show_spectrum

plot_spectrum(args[0], plotfile)

File "show_spectrum.py", line 230, in plot_spectrum

spec = get_spectrum_file(filename)

File "show_spectrum.py", line 59, in get_spectrum_file

return get_spectrum_fits(fits)

File "show_spectrum.py", line 81, in get_spectrum_fits

c_energy = table['e_ref']

File "/Users/chirri/opt/anaconda3/envs/chirri/lib/python3.5/site-packages/gammalib/fits.py", line 2279, in getitem

return fits.GFitsTable__getitem__ (self, *args)
RuntimeError: *** ERROR in GFitsTable::operator[](std::string&): Column "e_ref" not found in table"

| saw the file show_spectrum.py and | realized that is very different than the old version of the file show_spectrum.py, so you have
some advice for that or some solution?

Best regards.

History

#1 - 12/04/2020 11:56 AM - Tibaldo Luigi

Hi Christian,
could you please specify which are the two versions of ctools used to generate the spectral files and to plot?

#2 - 12/04/2020 12:07 PM - Diaz-Bahamondes Christian
- File show_spectrum_old.py added

- File show_spectrum_last.py added

user#266 wrote:

Hi Christian,
could you please specify which are the two versions of ctools used to generate the spectral files and to plot?

Yes, when | used the old version of 'show_spectrum.py' (v. 2015-2019) and | tried to make a graph with a new file for 'spectrum.fits' (last update of
ctools) doesn't work and this is the bug | show you. Viceversa is the same, | mean when | used the new version of 'show_spectrum.py' with last
version of 'spectrum.fits' doesn't work too. | attached the last version and new version of show_spectrum.py

Best regards

#3 - 12/04/2020 01:02 PM - Tibaldo Luigi
- Tracker changed from Bug to Support
- Status changed from New to Resolved

- % Done changed from 0 to 100

Hi Christian,

this is not a bug. In version 1.7 the format of the spectrum files was changed to support the storage of likelihood profiles, aka Castro plots, see #2938,
and also to make it more compliant with the community-defined format for interoperability reasons (
https://gamma-astro-data-formats.readthedocs.io/en/latest/spectra/flux_points/index.html#flux-points).

Unfortunately this means that spectrum files produced with ctools < 1.7.0 will not be readable with the example scripts shipped with ctools > 1.7.0. If
you need to read/plot old files please use the old version of the example plotting script.

#4 - 02/05/2021 07:57 AM - Knédlseder Jiirgen
https://gamma-astro-data-formats.readthedocs.io/en/latest/spectra/flux_points/index.html#flux-points

- Status changed from Resolved to Closed

- Assigned To set to Tibaldo Luigi
